//+------------------------------------------------------------------+
//|                                                          ATR.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_width1 2
//---- input parameters
extern int AtrPeriod=14;
extern int CountBars=500;
extern string IIIIIIIIIIIIIIIIIII="<<< Label Settings Settings >>>>>";
extern bool ATR_Script =false;// Label for ATR indicator when used as stand alone indicator 
extern bool ATR_Script2 =false;// Moving Label for ATR Line
extern int Label_Text_Size = 14;
extern color ATR_Label_color = MidnightBlue; //DeepSkyBlue;
extern string IIIIIIIIIIIIIIIIII="<<< Indicator Window Settings >>>>>";
extern bool Use_Indicator_Window = true;// Setting for using separate indicator window
extern int Select_Indicator_Window= 3;// Separate window number
extern bool Show_ATR_Line =false;// Show the ATR Line or Hide the ATR Line

//---- buffers
double AtrBuffer[];
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(2);
//---- indicator line
    if(Show_ATR_Line ==true){Show_ATR_Line=DRAW_LINE; }
    else {Show_ATR_Line=DRAW_NONE; }
   SetIndexStyle(0,Show_ATR_Line,STYLE_SOLID,2);
   SetIndexBuffer(0,AtrBuffer);
   SetIndexBuffer(1,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="ATR("+AtrPeriod+")";
   IndicatorShortName("ATR_LABEL");
   SetIndexLabel(0,"ATR_LABEL");
//----
   SetIndexDrawBegin(0,AtrPeriod);
//----
   return(0);
  }
  
  int deinit() 
    {
 //----   
  ObjectsDeleteAll(0,OBJ_LABEL);
  ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectDelete("ATR_Label");
   ObjectDelete("ATR_Label2");
    ObjectDelete("ATR_Label3");
 //----  
        }
   return(0);
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
  IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+0);
   SetIndexDrawBegin(0,Bars-CountBars);
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=AtrPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=AtrPeriod;i++) AtrBuffer[Bars-i]=0.0;
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer[i]=high-low;
      else
        {
         double prevclose=Close[i+1];
         if (TempBuffer[i]<= 50)
            {
             TempBuffer[i]=(MathMax(high,prevclose)-MathMin(low,prevclose))*10000;// <<<<<<<<<< NB Renier se veranderinge 13 Aug 2007
            }
         
         if (TempBuffer[i]> 50)
            { 
            TempBuffer[i]=(MathMax(high,prevclose)-MathMin(low,prevclose))*10000*0.7;// Ditto
            }
        }
      i--;
     }
     
     //Comment("");
//----
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
      AtrBuffer[i]=iMAOnArray(TempBuffer,Bars,AtrPeriod,0,MODE_SMA,i);
      
    if( ATR_Script==true ){ 
                    ObjectDelete("ATR_Label");   
                    ObjectCreate("ATR_Label", OBJ_LABEL,WindowFind("ATR_LABEL"), 0, 0);
   ObjectSetText("ATR_Label","ATR @ "+DoubleToStr(AtrBuffer[0],Digits)+"", Label_Text_Size, "Tahoma Narrow", ATR_Label_color);
   ObjectSet("ATR_Label", OBJPROP_CORNER, 1);
   ObjectSet("ATR_Label", OBJPROP_XDISTANCE, 80);
   ObjectSet("ATR_Label", OBJPROP_YDISTANCE, 10 ); 
    }
    
    if( ATR_Script2==true ){   
   ObjectDelete("ATR_Label2");
   if(ObjectFind("ATR_Label2") != 0) {
   ObjectCreate("ATR_Label2", OBJ_TEXT,WindowFind("ATR_LABEL"), Time[0],AtrBuffer[0]);
   ObjectSetText("ATR_Label2", "                 "+ DoubleToStr(AtrBuffer[0],Digits)+"", Label_Text_Size, "Arial Narrow",ATR_Label_color);
   } else{ ObjectMove("ATR_Label2", 0, Time[0],AtrBuffer[0]); }
   } 
   if(Use_Indicator_Window==true){   
           	           ObjectDelete("ATR_Label3");
      	              ObjectCreate("ATR_Label3", OBJ_LABEL, Select_Indicator_Window, 0, 0);
    ObjectSetText("ATR_Label3","ATR @ "+DoubleToStr(AtrBuffer[0],Digits)+"", Label_Text_Size, "Tahoma Narrow", MidnightBlue);//DeepSkyBlue
   ObjectSet("ATR_Label3", OBJPROP_CORNER,1);
   ObjectSet("ATR_Label3", OBJPROP_XDISTANCE,20);//80
   ObjectSet("ATR_Label3", OBJPROP_YDISTANCE, 10 );//10
   }
   
  //----{
   return(0);
   }
 